#include<math.h>
#include<gtk--.h>
#include"Movable.h"
#include"Drawable.h"
#include"Selectable.h"
#include"Shape.h"
#include"Arc.h"

Arc::Arc(gint x,gint y,gint width,gint height,
	GdkColor& foregroundColor,GdkColor& backgroundColor,bool filled) :
		Shape(foregroundColor,backgroundColor,filled)
{
	shape=arcShape;
	this->x=x;
	this->y=y;
	this->width=width;
	this->height=height;
}
Arc::Arc(gint x,gint y,gint width,gint height)
{
	this->x=x;
	this->y=y;
	this->width=width;
	this->height=height;
}
bool Arc::contains(gint x,gint y)
{
	gdouble a,b;
	gdouble centerX,centerY;

	a=(gdouble)(width)/2;
	b=(gdouble)(height)/2;

	centerX=((gdouble)(this->x)*2+(gdouble)(width))/2;
	centerY=((gdouble)(this->y)*2+(gdouble)(height))/2;

	gdouble f,g;

	f=pow((x-centerX),2)/pow(a,2);
	g=pow((y-centerY),2)/pow(b,2);

	if(f+g<1)
		return true;

	return false;
}
bool Arc::on_path(gint x,gint y)
{
	if(filled)
		return contains(x,y);

	Arc bigArc(this->x-range,this->y-range,width+range*2,height+range*2);
	Arc smallArc(this->x+range,this->y+range,width-range*2,height-range*2);
	
	if(bigArc.contains(x,y)&&!smallArc.contains(x,y))
		return true;

	return false;
}
void Arc::draw(GdkPixmap* buffer,GdkGC* GC)
{
	if(changeColor)
	{
		gdk_color_alloc(gdk_colormap_get_system(),&foregroundColor);
		changeColor=false;
	}
	gdk_gc_set_foreground(GC,&foregroundColor);
	gdk_draw_arc(buffer,GC,filled,x,y,width,height,0,360*64);
}
