#include<math.h>
#include<gtk--.h>
#include"Movable.h"
#include"Drawable.h"
#include"Selectable.h"
#include"Shape.h"
#include"Line.h"
#include"Rectangle.h"

Line::Line(gint x1,gint y1,gint x2,gint y2,
	GdkColor& foregroundColor,GdkColor& backgroundColor) :
		Shape(foregroundColor,backgroundColor,false)
{
	shape=lineShape;
	this->x1=x1;
	this->y1=y1;
	this->x2=x2;
	this->y2=y2;
}
bool Line::contains(gint x,gint y)
{
	return on_path(x,y);
}
bool Line::on_path(gint x,gint y)
{
	gint newX1,newY1,newX2,newY2;

	if(x2-x1>0)
	{
		newX1=x1;
		newX2=x2;
	}
	else
	{
		newX1=x2;
		newX2=x1;
	}

	if(y2-y1>0)
	{
		newY1=y1;
		newY2=y2;
	}
	else
	{
		newY1=y2;
		newY2=y1;
	}

	Rectangle rect(newX1-range,newY1-range,newX2-newX1+range*2,
		newY2-newY1+range*2);

	if(!rect.contains(x,y))
		return false;

	if(newX1==newX2)
		return true;
	
	gdouble a,b,c;
	gdouble d,d1,d2;;

	a=(gdouble)(y2-y1)/(gdouble)(x2-x1);
	b=-1.0;
	c=(gdouble)(y1)-(gdouble)(x1)*a;

	d1=fabs(a*x+b*y+c);
	d2=hypot(a,b);

	d=d1/d2;

	if(d<range)
		return true;

	return false;
}
void Line::draw(GdkPixmap* buffer,GdkGC* GC)
{
	if(changeColor)
	{
		gdk_color_alloc(gdk_colormap_get_system(),&foregroundColor);
		changeColor=false;
	}
	gdk_gc_set_foreground(GC,&foregroundColor);
	gdk_draw_line(buffer,GC,x1,y1,x2,y2);
}
