#include<string.h>
#include<list.h>
#include<gtk--.h>
#include"Movable.h"
#include"Drawable.h"
#include"Selectable.h"
#include"Shape.h"
#include"Line.h"
#include"Rectangle.h"
#include"Arc.h"
#include"Text.h"
#include"OhharaCanvas.h"

OhharaCanvas::OhharaCanvas() : Gtk_DrawingArea(),buffer(0),width(0),height(0),
	GC(0),drawingShape(NULL)
{
	gint mask=gtk_widget_get_events(GTK_WIDGET(gtkobject));
	mask|=GDK_EXPOSURE_MASK;
	mask|=GDK_POINTER_MOTION_MASK;
	mask|=GDK_BUTTON_PRESS_MASK;
	mask|=GDK_BUTTON_RELEASE_MASK;
	mask|=GDK_KEY_PRESS_MASK;
	mask|=GDK_ENTER_NOTIFY_MASK;
	mask|=GDK_LEAVE_NOTIFY_MASK;
	gtk_widget_set_events(GTK_WIDGET(gtkobject),mask);

	textFont=gdk_font_load("-adobe-helvetica-medium-r-normal--12-*-*-*-*-*-*-*");
}
OhharaCanvas::~OhharaCanvas()
{
	if(buffer)
		gdk_pixmap_unref(buffer);
	if(GC)
		gdk_gc_destroy(GC);
}
GdkGC* OhharaCanvas::getGC()
{
	if(GC==0)
		GC=gdk_gc_new(GTK_WIDGET(gtkobject)->window);
	return GC;
}
void OhharaCanvas::clear()
{
	gdk_draw_rectangle(buffer,GTK_WIDGET(gtkobject)->style->white_gc,true,0,0,
		width,height);
}
void OhharaCanvas::set_noclip()
{
	gdk_gc_set_clip_mask(getGC(),0);
}
void OhharaCanvas::draw_line(gint x1,gint y1,gint x2,gint y2,
	GdkColor& foregroundColor,GdkColor& backgroundColor,GdkGC* GC=0)
{
	shapeList.push_back(new Line(x1,y1,x2,y2,foregroundColor,backgroundColor));
	gint width,height;
	width=x2-x1;
	height=y2-y1;
	if(width<0)
	{
		x1=x1+width;
		width=-width;
	}
	if(height<0)
	{
		y1=y1+height;
		height=-height;
	}
	delete_shape();
}
void OhharaCanvas::drawing_line(gint x1,gint y1,gint x2,gint y2,
	GdkColor& foregroundColor,GdkColor& backgroundColor,GdkGC* GC=0)
{
	if(drawingShape==NULL)
		drawingShape=new Line(x1,y1,x2,y2,foregroundColor,backgroundColor);
	else
	{
		drawingShape->set_pos1(x1,y1);
		drawingShape->set_pos2(x2,y2);
		refresh_all();
	}
}
void OhharaCanvas::draw_rectangle(gint x,gint y,gint width,gint height,
	GdkColor& foregroundColor,GdkColor& backgroundColor,bool filled,GdkGC* GC=0)
{
	shapeList.push_back(new Rectangle(x,y,width,height,foregroundColor,
		backgroundColor,filled));
	delete_shape();
}
void OhharaCanvas::drawing_rectangle(gint x,gint y,gint width,gint height,
	GdkColor& foregroundColor,GdkColor& backgroundColor,bool filled,GdkGC* GC=0)
{
	if(drawingShape==NULL)
		drawingShape=new Rectangle(x,y,width,height,foregroundColor,
			backgroundColor,filled);
	else
	{
		drawingShape->set_pos(x,y);
		drawingShape->set_size(width,height);
		drawingShape->set_filled(filled);
		refresh_all();
	}
}
void OhharaCanvas::draw_arc(gint x,gint y,gint width,gint height,
	GdkColor& foregroundColor,GdkColor& backgroundColor,bool filled,GdkGC* GC=0)
{
	shapeList.push_back(new Arc(x,y,width,height,foregroundColor,
		backgroundColor,filled));
	delete_shape();
}
void OhharaCanvas::drawing_arc(gint x,gint y,gint width,gint height,
	GdkColor& foregroundColor,GdkColor& backgroundColor,bool filled,GdkGC* GC=0)
{
	if(drawingShape==NULL)
		drawingShape=new Arc(x,y,width,height,foregroundColor,backgroundColor,
			filled);
	else
	{
		drawingShape->set_pos(x,y);
		drawingShape->set_size(width,height);
		drawingShape->set_filled(filled);
		refresh_all();
	}
}
void OhharaCanvas::draw_text(gint x,gint y,gchar* textData,
	GdkColor& foregroundColor,GdkColor& backgroundColor,GdkGC* GC=0)
{
	shapeList.push_back(new Text(x,y,textFont,textData,foregroundColor,
		backgroundColor));
	delete_shape();
}
void OhharaCanvas::drawing_text(gint x,gint y,gchar* textData,
	GdkColor& foregroundColor,GdkColor& backgroundColor,GdkGC* GC=0)
{
	gchar tmpText[1025];
	if(drawingShape==NULL)
	{
		strcpy(tmpText,textData);
		strcat(tmpText,"|");
		drawingShape=new Text(x,y,textFont,tmpText,foregroundColor,backgroundColor);
		refresh_all();
	}
	else
	{
		strcpy(tmpText,textData);
		strcat(tmpText,"|");
		*drawingShape<<tmpText;
		refresh_all();
	}
}

void OhharaCanvas::delete_shape()
{
	if(drawingShape!=NULL)
	{
		delete drawingShape;
		drawingShape=NULL;
	}

	refresh_all();
}
void OhharaCanvas::draw_all()
{
	shapeListIterator=shapeList.begin();
	for(int i=0;i<shapeList.size();i++,shapeListIterator++)
		(*shapeListIterator)->draw(buffer,getGC());
	if(drawingShape!=NULL)
		drawingShape->draw(buffer,getGC());
}
void OhharaCanvas::refresh(gint x,gint y,gint width,gint height)
{
	set_noclip();
	clear();
	draw_all();
	gdk_draw_pixmap(GTK_WIDGET(gtkobject)->window,
		GTK_WIDGET(gtkobject)->style->fg_gc[GTK_WIDGET_STATE(gtkobject)],buffer,
		x,y,x,y,width,height);
}
void OhharaCanvas::refresh_all()
{
	refresh(0,0,width,height);
}
Shape* OhharaCanvas::find_shape(gint x,gint y)
{
	shapeListIterator=shapeList.end();
	shapeListIterator--;
	for(int i=0;i<shapeList.size();i++,shapeListIterator--)
	{
		if((*shapeListIterator)->on_path(x,y)==true)
			return *shapeListIterator;
	}
	return NULL;
}
void OhharaCanvas::remove_shape(gint x,gint y)
{
	Shape* tmpShape;
	tmpShape=find_shape(x,y);
	if(tmpShape!=NULL)
		shapeList.remove(tmpShape);
	refresh_all();
}
void OhharaCanvas::remove_all()
{
	shapeList.erase(shapeList.begin(),shapeList.end());
	refresh_all();
}
list<Shape*>& OhharaCanvas::get_shapeList()
{
	return shapeList;
}
GdkFont* OhharaCanvas::get_textFont()
{
	return textFont;
}
gint OhharaCanvas::expose_event_impl(GdkEventExpose* e)
{
	refresh(e->area.x,e->area.y,e->area.width,e->area.height);
	return Gtk_DrawingArea::expose_event_impl(e);
}
gint OhharaCanvas::configure_event_impl(GdkEventConfigure* e)
{
	if(buffer)
		gdk_pixmap_unref(buffer);
	buffer=gdk_pixmap_new(GTK_WIDGET(gtkobject)->window,width=e->width,
		height=e->height,-1);
	clear();
	set_noclip();
	return Gtk_DrawingArea::configure_event_impl(e);
}
