#ifndef _OHHARACANVAS_H
#define _OHHARACANVAS_H

class OhharaCanvas : public Gtk_DrawingArea
{
private:
	GdkPixmap* buffer;
	GdkGC* GC;
	gint width,height;
	Shape* shape;
	list<Shape*> shapeList;
	list<Shape*>::iterator shapeListIterator;
	Shape* drawingShape;
	GdkFont* textFont;
public:
	OhharaCanvas();
	~OhharaCanvas();
	GdkGC* getGC();
	virtual void clear();
	void set_noclip();
	void draw_line(gint x1,gint y1,gint x2,gint y2,GdkColor& foregroundColor,
		GdkColor& backgroundColor,GdkGC* GC=0);
	void drawing_line(gint x1,gint y1,gint x2,gint y2,GdkColor& foregroundColor,
		GdkColor& backgroundColor,GdkGC* GC=0);
	void draw_rectangle(gint x,gint y,gint width,gint height,
		GdkColor& foregroundColor,GdkColor& backgroundColor,bool filled,
		GdkGC* GC=0);
	void drawing_rectangle(gint x,gint y,gint width,gint height,
		GdkColor& foregroundColor,GdkColor& backgroundColor,bool filled,
		GdkGC* GC=0);
	void draw_arc(gint x,gint y,gint width,gint height,
		GdkColor& foregroundColor,GdkColor& backgroundColor,bool filled,
		GdkGC* GC=0);
	void drawing_arc(gint x,gint y,gint width,gint height,
		GdkColor& foregroundColor,GdkColor& backgroundColor,bool filled,
		GdkGC* GC=0);
	void draw_text(gint x,gint y,gchar* text,
		GdkColor& foregroundColor,GdkColor& backgroundColor,GdkGC* GC=0);
	void drawing_text(gint x,gint y,gchar* text,
		GdkColor& foregroundColor,GdkColor& backgroundColor,GdkGC* GC=0);
	void delete_shape();
	void draw_all();
	void refresh(gint x,gint y,gint width,gint height);
	void refresh_all();
	Shape* find_shape(gint x,gint y);
	void remove_shape(gint x,gint y);
	void remove_all();
	list<Shape*>& get_shapeList();
	GdkFont* get_textFont();
	virtual gint expose_event_impl(GdkEventExpose* e);
	virtual gint configure_event_impl(GdkEventConfigure* e);
};

#endif
