#ifndef _OHHARADRAW_H
#define _OHHARADRAW_H

class OhharaDraw : public Gtk_Window
{

	const gint line=10;
	const gint lineFirstPointSet=20;
	const gint rectangle=30;
	const gint rectangleFirstPointSet=40;
	const gint arc=50;
	const gint arcFirstPointSet=60;
	const gint text=70;
	const gint textPointSet=80;
	const gint changeColor=500;
	const gint move=510;
	const gint moveShapeSet=520;
	const gint remove=530;

	gint state;

	const gint canvasWidth=500;
	const gint canvasHeight=400;

	gint x;
	gint y;
	gint x1;
	gint y1;
	gint x2;
	gint y2;
	gint width;
	gint height;

	gint tmpX;
	gint tmpY;
	gint tmpX1;
	gint tmpY1;
	gint tmpX2;
	gint tmpY2;

	gint movingX;
	gint movingY;

	gchar textData[1024];

	GdkColor foregroundColor;
	GdkColor backgroundColor;

	Gtk_VBox ohharaDrawVBox;
	Gtk_MenuBar ohharaDrawMenuBar;
	Gtk_Menu fileMenu;
	Gtk_Menu helpMenu;
	Gtk_MenuItem fileItem,newItem,openItem,saveItem,quitItem,helpItem,aboutItem;
	Gtk_Toolbar ohharaToolbar;
	Gtk_Button newButton;
	Gtk_Pixmap newPixmap;
	Gtk_Button openButton;
	Gtk_Pixmap openPixmap;
	Gtk_Button saveButton;
	Gtk_Pixmap savePixmap;
	Gtk_Button helpButton;
	Gtk_Pixmap helpPixmap;
	Gtk_Toolbar ohharaDrawToolbar;
	Gtk_Button lineButton;
	Gtk_Pixmap linePixmap;
	Gtk_Button rectangleButton;
	Gtk_Pixmap rectanglePixmap;
	Gtk_Button arcButton;
	Gtk_Pixmap arcPixmap;
	Gtk_Button textButton;
	Gtk_Pixmap textPixmap;
	Gtk_ToggleButton filledToggleButton;
	Gtk_Pixmap filledPixmap;
	Gtk_ToggleButton regularToggleButton;
	Gtk_Pixmap regularPixmap;
	Gtk_Button colorSelectionButton;
	Gtk_Pixmap colorSelectionPixmap;
	Gtk_Button moveButton;
	Gtk_Pixmap movePixmap;
	Gtk_Button removeButton;
	Gtk_Pixmap removePixmap;
	Gtk_HRuler ohharaDrawHRuler;
	Gtk_VRuler ohharaDrawVRuler;
	OhharaCanvas ohharaCanvas;
	Gtk_Table ohharaCanvasTable;
	Gtk_Dialog ohharaDrawHelpDialog;

	Gtk_ColorSelectionDialog colorSelectionDialog;
	Gtk_FileSelection openFileSelection;
	Gtk_FileSelection saveFileSelection;

	Gtk_Pixmap ohharaDrawPixmap;
	Gtk_Label ohharaDrawLabel;
	Gtk_Label ohharaDrawLicense;
	Gtk_Button ohharaDrawButton;

	Shape* movingShape;

public:
	OhharaDraw();
	~OhharaDraw();
	virtual gint delete_event_impl(GdkEventAny* gdkEventAny);
	gint emit_to_OhharaDrawHRuler(GdkEventMotion* p1);
	gint ohharaCanvas_motion_notify_event_impl(GdkEventMotion* e);
	gint ohharaCanvas_button_press_event_impl(GdkEventButton* e);
	gint key_press_event_impl(GdkEventKey* p1);
	void newButton_clicked_impl();
	void openButton_clicked_impl();
	void open_file();
	void donot_open_file();
	void save_file();
	void donot_save_file();
	void saveButton_clicked_impl();
	void aboutButton_clicked_impl();
	void close_Help();
	void lineButton_clicked_impl();
	void rectangleButton_clicked_impl();
	void arcButton_clicked_impl();
	void textButton_clicked_impl();
	void check_state();
	void colorSelectionButton_clicked_impl();
	void change_foregroundColor();
	void donot_change_foregroundColor();
	void moveButton_clicked_impl();
	void removeButton_clicked_impl();
};

#endif
