#include<gtk--.h>
#include"Movable.h"
#include"Drawable.h"
#include"Selectable.h"
#include"Shape.h"
#include"Rectangle.h"

Rectangle::Rectangle(gint x,gint y,gint width,gint height,
	GdkColor& foregroundColor,GdkColor& backgroundColor,bool filled) :
		Shape(foregroundColor,backgroundColor,filled)
{
	shape=rectangleShape;
	this->x=x;
	this->y=y;
	this->width=width;
	this->height=height;
}
Rectangle::Rectangle(gint x,gint y,gint width,gint height)
{
	this->x=x;
	this->y=y;
	this->width=width;
	this->height=height;
}
bool Rectangle::contains(gint x,gint y)
{
	if(x>this->x&&x<this->x+width&&y>this->y&&y<this->y+height)
		return true;
	return false;
}
bool Rectangle::on_path(gint x,gint y)
{
	if(filled)
		return contains(x,y);

	Rectangle bigRectangle(this->x-range,this->y-range,width+range*2,
		height+range*2);
	Rectangle smallRectangle(this->x+range,this->y+range,width-range*2,
		height-range*2);

	if(bigRectangle.contains(x,y)&&!smallRectangle.contains(x,y))
		return true;

	return false;
}
void Rectangle::draw(GdkPixmap* buffer,GdkGC* GC)
{
	if(changeColor)
	{
		gdk_color_alloc(gdk_colormap_get_system(),&foregroundColor);
		changeColor=false;
	}
	gdk_gc_set_foreground(GC,&foregroundColor);
	gdk_draw_rectangle(buffer,GC,filled,x,y,width,height);
}
